

class RealSqRoot {
  public static void main(String[] args) {
    System.out.println("sqrt(13.0) is " + Math.sqrt(13.0));
    System.out.println("sqrt(-4.0) is " + Math.sqrt(-4.0));
    System.out.println("sqrt(9.0) is " + Math.sqrt(9.0));
  }
}


aspect EnsureRealRoot {

/*
 *   before(double d) : call(static double Math.sqrt(double)) && args(d) {
 *     if (d < 0.0)
 *       throw new IllegalArgumentException("Positive arguments to sqrt() only!");
 *   }
 *
 *                 */

/*  
 *   before(double d) : call(static double Math.sqrt(double)) && args(d) {
 *     if (d < 0.0) {
 *        System.out.println("positive arguments to sqrt() only!");
 *     }
 *   }
 *
 *                    */


  double around(double d) : 
    call(static double Math.sqrt(double)) && args(d) {
      if (d < 0.0) { 
        d = -d; 
        System.out.print("( neg arg modified to: "+d+" ) "); 
      }
      return proceed(d); 
  }

}

